/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "gpe/init.h"

#include "interface.h"
#include "support.h"

#include "brightness.h"
#include "rotation.h"

int initialising;

int
main (int argc, char *argv[])
{
  GtkWidget *mainwindow;
  GtkWidget *brightnesscontrol;
  GtkAdjustment *adjustment;
  GtkEditable *editable;
  char *rotation;
  int l;

  initialising = 1;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  if (gpe_application_init (&argc, &argv) == FALSE)
    {
      exit (1);
    }

  setlocale (LC_ALL, "");

  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);

/*
  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");
*/

  mainwindow = create_mainwindow ();

  brightnesscontrol = lookup_widget (mainwindow, "brightness_hscale");
  adjustment = gtk_range_get_adjustment (GTK_RANGE(brightnesscontrol));
  gtk_adjustment_set_value (adjustment, (gfloat) get_brightness () / 2.55);
  gtk_range_set_adjustment (GTK_RANGE(brightnesscontrol), adjustment);

  editable = GTK_EDITABLE(lookup_widget (mainwindow, "rotation_entry"));
  gtk_editable_delete_text (editable, 0, -1);
  l = 0;
  rotation = get_rotation();
  gtk_editable_insert_text (editable, rotation, strlen(rotation), &l);

  gtk_widget_show (mainwindow);

  initialising = 0;

  gtk_main ();
  return 0;
}

