/*	$Id: palette.c,v 1.1 2003/06/25 21:28:20 pb Exp $	*/

/*
 * Copyright (c) 1996
 *	Sandro Sigala, Brescia, Italy.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Sandro Sigala.
 * 4. Neither the name of the author nor the names of any contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

static struct { unsigned char r, g, b; } game_palette[] = {
	{0, 0, 0},
	{0, 0, 42},
	{0, 42, 0},
	{0, 42, 42},
	{42, 0, 0},
	{42, 0, 42},
	{42, 21, 0},
	{42, 42, 42},
	{21, 21, 21},
	{21, 21, 63},
	{21, 63, 21},
	{21, 63, 63},
	{63, 21, 21},
	{63, 21, 63},
	{63, 63, 21},
	{63, 63, 63},
	{0, 0, 0},
	{5, 5, 5},
	{8, 8, 8},
	{11, 11, 11},
	{14, 14, 14},
	{17, 17, 17},
	{20, 20, 20},
	{24, 24, 24},
	{28, 28, 28},
	{32, 32, 32},
	{36, 36, 36},
	{40, 40, 40},
	{45, 45, 45},
	{50, 50, 50},
	{56, 56, 56},
	{63, 63, 63},
	{0, 0, 63},
	{16, 0, 63},
	{31, 0, 63},
	{47, 0, 63},
	{63, 0, 63},
	{63, 0, 47},
	{63, 0, 31},
	{63, 0, 16},
	{63, 0, 0},
	{63, 16, 0},
	{63, 31, 0},
	{63, 47, 0},
	{63, 63, 0},
	{47, 63, 0},
	{31, 63, 0},
	{16, 63, 0},
	{0, 63, 0},
	{0, 63, 16},
	{0, 63, 31},
	{0, 63, 47},
	{0, 63, 63},
	{0, 47, 63},
	{0, 31, 63},
	{0, 16, 63},
	{31, 31, 63},
	{39, 31, 63},
	{47, 31, 63},
	{55, 31, 63},
	{63, 31, 63},
	{63, 31, 55},
	{63, 31, 47},
	{63, 31, 39},
	{63, 31, 31},
	{63, 39, 31},
	{63, 47, 31},
	{63, 55, 31},
	{63, 63, 31},
	{55, 63, 31},
	{47, 63, 31},
	{39, 63, 31},
	{31, 63, 31},
	{31, 63, 39},
	{31, 63, 47},
	{31, 63, 55},
	{31, 63, 63},
	{31, 55, 63},
	{31, 47, 63},
	{31, 39, 63},
	{45, 45, 63},
	{49, 45, 63},
	{54, 45, 63},
	{58, 45, 63},
	{63, 45, 63},
	{63, 45, 58},
	{63, 45, 54},
	{63, 45, 49},
	{63, 45, 45},
	{63, 49, 45},
	{63, 54, 45},
	{63, 58, 45},
	{63, 63, 45},
	{58, 63, 45},
	{54, 63, 45},
	{49, 63, 45},
	{45, 63, 45},
	{45, 63, 49},
	{45, 63, 54},
	{45, 63, 58},
	{45, 63, 63},
	{45, 58, 63},
	{45, 54, 63},
	{45, 49, 63},
	{0, 0, 28},
	{7, 0, 28},
	{14, 0, 28},
	{21, 0, 28},
	{28, 0, 28},
	{28, 0, 21},
	{28, 0, 14},
	{28, 0, 7},
	{28, 0, 0},
	{28, 7, 0},
	{28, 14, 0},
	{28, 21, 0},
	{28, 29, 0},
	{21, 28, 0},
	{14, 28, 0},
	{7, 28, 0},
	{0, 28, 0},
	{0, 28, 7},
	{0, 28, 14},
	{0, 28, 21},
	{0, 28, 28},
	{0, 21, 28},
	{0, 14, 28},
	{0, 7, 28},
	{14, 14, 28},
	{17, 14, 28},
	{21, 14, 28},
	{24, 14, 28},
	{28, 14, 28},
	{28, 14, 24},
	{28, 14, 21},
	{28, 14, 17},
	{28, 14, 14},
	{28, 17, 14},
	{28, 21, 14},
	{28, 24, 14},
	{28, 28, 14},
	{24, 28, 14},
	{21, 28, 14},
	{17, 28, 14},
	{14, 28, 14},
	{14, 28, 17},
	{14, 28, 21},
	{14, 28, 24},
	{14, 28, 28},
	{14, 24, 28},
	{14, 21, 28},
	{14, 17, 28},
	{20, 20, 28},
	{22, 20, 28},
	{24, 20, 28},
	{26, 20, 28},
	{28, 20, 28},
	{28, 20, 26},
	{28, 20, 24},
	{28, 20, 22},
	{28, 20, 20},
	{28, 22, 20},
	{28, 24, 20},
	{28, 26, 20},
	{28, 28, 20},
	{26, 28, 20},
	{24, 28, 20},
	{22, 28, 20},
	{20, 28, 20},
	{20, 28, 22},
	{20, 28, 24},
	{20, 28, 26},
	{20, 28, 28},
	{20, 26, 28},
	{20, 24, 28},
	{20, 22, 28},
	{0, 0, 16},
	{4, 0, 16},
	{8, 0, 16},
	{12, 0, 16},
	{16, 0, 16},
	{16, 0, 12},
	{16, 0, 8},
	{16, 0, 4},
	{16, 0, 0},
	{16, 4, 0},
	{16, 8, 0},
	{16, 12, 0},
	{16, 16, 0},
	{12, 16, 0},
	{8, 16, 0},
	{4, 16, 0},
	{0, 16, 0},
	{0, 16, 4},
	{0, 16, 8},
	{0, 16, 12},
	{0, 16, 16},
	{0, 12, 16},
	{0, 8, 16},
	{0, 4, 16},
	{8, 8, 16},
	{10, 8, 16},
	{12, 8, 16},
	{14, 8, 16},
	{16, 8, 16},
	{16, 8, 14},
	{16, 8, 12},
	{16, 8, 10},
	{16, 8, 8},
	{16, 10, 8},
	{16, 12, 8},
	{16, 14, 8},
	{16, 16, 8},
	{14, 16, 8},
	{12, 16, 8},
	{10, 16, 8},
	{8, 16, 8},
	{8, 16, 10},
	{8, 16, 12},
	{8, 16, 14},
	{8, 16, 16},
	{8, 14, 16},
	{8, 12, 16},
	{8, 10, 16},
	{11, 11, 16},
	{12, 11, 16},
	{13, 11, 16},
	{15, 11, 16},
	{16, 11, 16},
	{16, 11, 15},
	{16, 11, 13},
	{16, 11, 12},
	{16, 11, 11},
	{16, 12, 11},
	{16, 13, 11},
	{16, 15, 11},
	{16, 16, 11},
	{15, 16, 11},
	{13, 16, 11},
	{12, 16, 11},
	{11, 16, 11},
	{11, 16, 12},
	{11, 16, 13},
	{11, 16, 15},
	{11, 16, 16},
	{11, 15, 16},
	{11, 13, 16},
	{11, 12, 16},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
	{0, 0, 0},
};
